use crate::soundclips::SoundClip;
use crate::vbplay::AudioThread;
use axum::extract::FromRef;
use axum_template::engine::Engine;
use minijinja::Environment;
use std::sync::{Arc, Mutex};

pub type TemplateEngine = Engine<Environment<'static>>;

#[derive(Clone)]
pub struct AppState {
    pub engine: TemplateEngine,
    pub clips: Vec<SoundClip>,
    pub player: Arc<Mutex<AudioThread>>,
}

impl FromRef<AppState> for TemplateEngine {
    fn from_ref(state: &AppState) -> Self {
        state.engine.clone()
    }
}
